#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>
#include "signatures.h"

signed short _stdcall DS_Scan(HWND hWnd,char* file)
{
	// Allocate memory (max. 82 tracks  11264 bytes)
	char *buffer;
	buffer = (char*) malloc(923650);
	if(buffer == NULL)
	{
		MessageBox(hWnd,"DeepScan: malloc() failed. Not enough memory available.",NULL,MB_OK | MB_ICONSTOP);
		return -1;
	}
	// Open the file
	ifstream stream(file,ios::nocreate | ios::binary);
	if(stream.is_open() == false)
	{
		free(buffer);
		MessageBox(hWnd,"DeepScan: The given file could not be found.",NULL,MB_OK | MB_ICONSTOP);
		return -2;
	}
	// Fill the buffer and close the file
	stream.seekg(0,ios::end);
	long filesize = stream.tellg();
	if(filesize > 923648)
	{
		stream.close();
		free(buffer);
		MessageBox(hWnd,"DeepScan: Extended ADFs are not supported.",NULL,MB_OK | MB_ICONSTOP);
		return -3;
	}
	stream.seekg(0,ios::beg);
	stream.read(buffer,filesize);
	stream.close();

	// OFS or FFS ?
	char flags; bool isFFS = false;
	flags = buffer[3];
	if(flags << 7 > 127) isFFS = true;

	if(isFFS) // FFS is not supported yet...
	{
	//	free(buffer);
	//	return 0;
	}

	// For each block... (1760 blocks  512 bytes)
	char byteArray[30]; unsigned short bytePos;
	for(short block=2;block<1760;block++)
	{
		// Happy New Year 96 (Linkvirus)
		for(bytePos=0;bytePos<strlen(HNY96_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+HNY96_SIGOFFSET+bytePos];
		byteArray[strlen(HNY96_SIGNATURE)] = NULL;
		if(strcmp(HNY96_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return HNY96_RETURNVAL;
		}

		// BGS9 (Filevirus)
		for(bytePos=0;bytePos<strlen(BGS9_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+BGS9_SIGOFFSET+bytePos];
		byteArray[strlen(BGS9_SIGNATURE)] = NULL;
		if(strcmp(BGS9_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return BGS9_RETURNVAL;
		}

		// Butonic v3.00 (Filevirus)
		for(bytePos=0;bytePos<strlen(BUTONIC3_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+BUTONIC3_SIGOFFSET+bytePos];
		byteArray[strlen(BUTONIC3_SIGNATURE)] = NULL;
		if(strcmp(BUTONIC3_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return BUTONIC3_RETURNVAL;
		}

		// Saddam 1 (Filevirus)
		for(bytePos=0;bytePos<strlen(SADDAM_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+SADDAM_SIGOFFSET+bytePos];
		byteArray[strlen(SADDAM_SIGNATURE)] = NULL;
		if(strcmp(SADDAM_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return SADDAM_RETURNVAL;
		}

		// Liberator v5.01 (Filevirus)

		if(isFFS) {for(bytePos=0;bytePos<strlen(LIB5_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+LIB5_FFSOFFSET+bytePos];}
		else      {for(bytePos=0;bytePos<strlen(LIB5_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+LIB5_SIGOFFSET+bytePos];}

		byteArray[strlen(LIB5_SIGNATURE)] = NULL;
		if(strcmp(LIB5_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return LIB5_RETURNVAL;
		}
		// Disaster Master 2 (Filevirus)
		for(bytePos=0;bytePos<strlen(DM2_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+DM2_SIGOFFSET+bytePos];
		byteArray[strlen(DM2_SIGNATURE)] = NULL;
		if(strcmp(DM2_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return DM2_RETURNVAL;
		}
		// CCCP (Linkvirus)
		for(bytePos=0;bytePos<strlen(CCCP_SIGNATURE);bytePos++) byteArray[bytePos] = buffer[block*512+CCCP_SIGOFFSET+bytePos];
		byteArray[strlen(CCCP_SIGNATURE)] = NULL;
		if(strcmp(CCCP_SIGNATURE,byteArray) == 0)
		{
			free(buffer);
			return CCCP_RETURNVAL;
		}
	}
	// No virus, no error
	free(buffer);
	return 0;
}